/* vim: set sw=4 sts=4: -*- Mode: c; tab-width: 8; c-basic-offset: 4; indent-tabs-mode: t; -*- */
#include <stdio.h>
#include <string.h>
#include <ctype.h>

static const char *uri_allowed_set = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-._~:/?#[]@!$&'()*+,;=";

int
main ()
{
    int i;

    printf ("/* %s */\n", uri_allowed_set);
    printf ("static const char uri_allowed_set[256] = {\n 0,");
    for (i = 1; i < 256; i++) {
	printf (strchr (uri_allowed_set, (char) i) ? " 1" : " 0");

	if (isgraph (i))
	    printf (" /*%c*/", i);

	putchar(',');
	if (i % 8 == 7)
	    putchar('\n');
    }
    printf ("};\n");
    return 0;
}
